
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret                                           //
// (C) Idiap Research Institute                                          //
//                                                                       //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#include "classifier_reader.h"
#include "misc.h"
#include "boosted_classifier.h"

Classifier *read_classifier(istream *is) {
  Classifier *result;
  unsigned int id;

  read_var(is, &id);

  switch(id) {
  case CLASSIFIER_BOOSTED:
    result = new BoostedClassifier();
    break;
  default:
    cerr << "Unknown classifier ID " << id << endl;
    exit(1);
  }

  result->read(is);
  return result;
}
