
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret                                           //
// (C) Idiap Research Institute                                          //
//                                                                       //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

/*

  A class to parse the arguments from the command line.

 */

#ifndef PARAM_PARSER_H
#define PARAM_PARSER_H

#include <iostream>
#include "misc.h"

using namespace std;

class ParamParser {
  int _nb_max, _nb;
  char **_names, **_values;
  bool *_changed;
public:
  ParamParser();
  ~ParamParser();
  void add_association(const char *variable_name, const char *variable_value, bool change);
  char *get_association(const char *variable_name);
  int get_association_int(const char *variable_name);
  scalar_t get_association_scalar(const char *variable_name);
  bool get_association_bool(const char *variable_name);

  void parse_options(int argc, char **argv, bool allow_undefined, int *new_argc, char **new_argv);
  void print_all(ostream *os);
};

#endif
