
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret                                           //
// (C) Idiap Research Institute                                          //
//                                                                       //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

/*

  A tiny class to implement shared objects and lazy deletion. When you
  create a reference to such an object, call grab(), and when you
  destroy that reference, call release() which will delete it if no
  reference remains. Never delete it yourself!

 */

#ifndef SHARED_H
#define SHARED_H

#include "misc.h"

class Shared {
  int _nb_refs;
public:
  Shared();
  virtual ~Shared();
  void grab();
  void release();
};

#endif
